#include <stdio.h>
#include <stdlib.h>
#include <dos.h>
#include <conio.h>

#define BILY        0
#define CERNY       1
#define TAHU      150  // namisto 448

#define DEPTH      40  //MAXIMALNI PROHLEDAVACI hloubka
#define HISTORY   400  // zatim jen zabira pamet
#define OKRAJ      -1
#define NIC         0
#define PESECW      1
#define PESECB      2
#define STRELECW    3
#define STRELECB    4
#define KUNW        5
#define KUNB        6
#define VEZW        7
#define VEZB        8
#define DAMAB       9
#define DAMAW       10
#define KRALW       11
#define KRALB       12
#define TNSW        13
#define TNSB        14 // zbytek musi byt volny, nebot se pouziva k oznameni

#define ZAKLPOS      1
#define PRAZDNA      0


typedef struct {
  char pole[8+6][8+6];
  char rosadaw[2],rosadab[2];
  struct {
    char x,y,priznak;
  } pesecw[8], pesecb[8];
  struct {
    char wnaw, bnaw, wnab, bnab;
  } barevnost;
  char zablokovani_centra, priznak_volneho_sloupce[8];
} SACH;

typedef struct {
  long hodnoceni, poradi_tahu;
  } DPTH;

void nakrm(void); SACH postav(long b); void vypis(SACH a);
int je_barva(long i,short int tah); int gen(SACH a, int na_tahu);
void gen_kun(SACH sachovnice,int pol,short int tah); long konzole(void);
SACH tahni(SACH a, long th); long hodnoceni(SACH a, int natahu);
DPTH depthsearch(SACH a, long nath, int dpth_max, int dpth_start,long hodn_navr_min);
void user_see(SACH a, long hodn); long hodnota_figury(int f);
int bubble_tah(int sign); char barva_pole(int u,int v);

SACH operator++ (SACH b) { return(b); }

long pesecw_cena      =   1000,
     pesecb_cena      =  -1000,
     strelecw_cena    =   3300,
     strelecb_cena    =  -3300,
     kunw_cena        =   3200,
     kunb_cena        =  -3200,
     damaw_cena       =   8500,
     damab_cena       =  -8500,
     tnsw_cena        =  10000,
     tnsb_cena        = -10000,
     vezw_cena        =   5500,
     vezb_cena        =  -5500,
     volnepole_cena   =     30, //jenom jestli
     rosadamw         =    100,
     rosadavw         =    100,
     rosadamb         =   -100,
     rosadavb         =   -100,
     rosadamwOK       =    250,
     rosadavwOK       =    250,
     rosadambOK       =   -250,
     rosadavbOK       =   -250,
     stredovypesec    =     50;


SACH /*history[HISTORY],*/ pom;
long tah[TAHU], poz, cena[TAHU];
int tah_pocet,antiroch = 0, dep = 4, tahne, kaskada = 0;

int main() {

  struct time t;
  long a,b,c,d,i;
  DPTH ae;
  char p;

  gettime(&t);
  c = t.ti_sec*t.ti_hund;
  srandom(c);
  textmode(C80);
  textcolor(WHITE);
  clrscr();

  tahne = BILY;
  pom = postav(ZAKLPOS); c = 1;
  ae.hodnoceni = 0;
//  pom.pole[3][3] = KRALW; pom.pole[8+2][8+2] = KRALB; pom.pole[7+2][8+2] = DAMAB;

  while(1) {
  if(c == 1) c = 0; else c = 1;
  user_see(pom,ae.hodnoceni);
  if(c != tahne) {
    ae = depthsearch(pom,c,dep,0,-1500000000*((c==0) ? 1 : -1));
    gen(pom,c);
    pom = tahni(pom,ae.poradi_tahu);
  } else {
    while(1) {
      a = konzole(); i = 0; b = 0;
          if(a == -10) { // NEW GAME
            pom = postav(ZAKLPOS); c = 1; ae.hodnoceni = 0;
            printf("tahne bily (a/n)\n");
            while(((p = getch()) != 'a') && (p != 'n')) ;
            if(p == 'a') tahne = BILY; else tahne = CERNY;
            break;
          }
      gen(pom,c);
      while(tah[i] != -1) {
        if(tah[i] == a) { b = 1; break; }
        i++;
      }
      if(b != 1) { printf("spatny tah!\n"); continue; }
      else
        { pom = tahni(pom,a); break; }
    }
  }
  }

}

SACH postav(long b)
{
  SACH aa;
  int i,j,k;

  aa.barevnost.wnaw = 0;
  aa.barevnost.bnaw = 0;
  aa.barevnost.wnab = 0;
  aa.barevnost.bnab = 0;

  for(i = 0; i < 14; i++)
    for(j = 0; j < 14; j++) {
    aa.pole[i][j] = NIC;
    if((i < 3) || (i > 10) || (j < 3) || (j > 10))
          aa.pole[i][j]=OKRAJ;
    }
  aa.rosadaw[0] = 0; aa.rosadaw[1] = 0; aa.rosadab[0] = 0; aa.rosadab[1] = 0;
if(b == PRAZDNA) return(aa);  // neindexuje pesce !!!
if(b == ZAKLPOS) {
  aa.rosadaw[0] = 1; aa.rosadaw[1] = 1; aa.rosadab[0] = 1; aa.rosadab[1] = 1;
  for(i = 3; i <= 10; i++) {
    aa.pole[i][4] = PESECW;
    aa.pesecw[i-3].x = i;
    aa.pesecw[i-3].y = 4;
    aa.pesecw[i-3].priznak = 0;
    if(barva_pole(i,4) == 0) aa.barevnost.wnab++;
    else aa.barevnost.wnaw++;
    aa.pole[i][9] = PESECB;
    aa.pesecb[i-3].x = i;
    aa.pesecb[i-3].y = 9;
    aa.pesecb[i-3].priznak = 0;
    if(barva_pole(i,9) == 0) aa.barevnost.bnab++;
    else aa.barevnost.bnaw++;
    aa.priznak_volneho_sloupce[i-2] = 0;
  }
  aa.pole[3][3] = VEZW; aa.pole[10][3] = VEZW;
  aa.pole[3][10] = VEZB; aa.pole[10][10] = VEZB;

  aa.pole[4][3] = KUNW; aa.pole[9][3] = KUNW;
  aa.pole[4][10] = KUNB; aa.pole[9][10] = KUNB;

  aa.pole[5][3] = STRELECW; aa.pole[8][3] = STRELECW;
  aa.pole[5][10] = STRELECB; aa.pole[8][10] = STRELECB;

  aa.pole[6][3] = DAMAW; aa.pole[7][3] = KRALW;
  aa.pole[6][10] = DAMAB; aa.pole[7][10] = KRALB;

  aa.zablokovani_centra = 8;

return(aa);
}
}

void vypis(SACH a) {
  int i,j;
  char l,ll;

  printf("                                         \n");
  for(i = 10; i >= 3; i--) { // setupne - bili dole
  printf("                       %d  ",i-2);
    for(j = 3; j <= 10; j++) {
    l = ((((j+i) % 2) == 1) ? /*248*/176 : /*250*/32);
    ll = l;
    if(a.pole[j][i] == PESECW) l = 'P';
    if(a.pole[j][i] == PESECB) l = 'p';
    if(a.pole[j][i] == VEZW) l = 'V';
    if(a.pole[j][i] == VEZB) l = 'v';
    if(a.pole[j][i] == KUNW) l = 'J';
    if(a.pole[j][i] == KUNB) l = 'j';
    if(a.pole[j][i] == STRELECW) l = 'S';
    if(a.pole[j][i] == STRELECB) l = 's';
    if(a.pole[j][i] == KRALW) l = 'K';
    if(a.pole[j][i] == KRALB) l = 'k';
    if(a.pole[j][i] == DAMAW) l = 'D';
    if(a.pole[j][i] == DAMAB) l = 'd';
    if(a.pole[j][i] == TNSW) l = 2;
    if(a.pole[j][i] == TNSB) l = 1;
    printf("%c%c%c",ll,l,ll);
//    if(j != 10) printf(" ");
    }
//  if(i != 3) printf("\n                                                     \n");
//  else printf("");
    if(i != 3) printf("\n"); else printf("");
  }
  printf("\n                                         \n");
  printf("                             a  b  c  d  e  f  g  h\n");
//getch();
}

int gen(SACH a, int na_tahu) { // nakrmi tah[i] moznymi tahy
  int i,j,u,v,x,y,th,navrat = 0;
  long kava[TAHU],k;//, lava[TAHU];

  th = na_tahu;
  for(i = 0; i < TAHU; i++) { tah[i] = -1; if(antiroch == 0) cena[i] = -1500000000; }
  i = 0;
  for(j = 0; j <= 63; j++) {
    u = j % 8 + 3;
    v = (j - (j % 8))/8 + 3;

    if((((th == 0) && (a.pole[u][v] == KUNW)) || ((th == 1) && (a.pole[u][v] == KUNB))) || (((th == 0) && (a.pole[u][v] == TNSW)) || ((th == 1) && (a.pole[u][v] == TNSB)))) {

      if((je_barva(a.pole[u-1][v-2],th) == 0) && (a.pole[u-1][v-2] != OKRAJ)) { tah[i] = ((u-1-3)+(v-2-3)*8)*64 + u-3+(v-3)*8; if(antiroch == 0) cena[i]=-hodnota_figury(a.pole[u-1][v-2]); i++; }
      if((je_barva(a.pole[u-2][v-1],th) == 0) && (a.pole[u-2][v-1] != OKRAJ)) { tah[i] = ((u-2-3)+(v-1-3)*8)*64 + u-3+(v-3)*8; if(antiroch == 0) cena[i]=-hodnota_figury(a.pole[u-2][v-1]); i++; }
      if((je_barva(a.pole[u-2][v+1],th) == 0) && (a.pole[u-2][v+1] != OKRAJ)) { tah[i] = ((u-2-3)+(v+1-3)*8)*64 + u-3+(v-3)*8; if(antiroch == 0) cena[i]=-hodnota_figury(a.pole[u-2][v+1]); i++; }
      if((je_barva(a.pole[u-1][v+2],th) == 0) && (a.pole[u-1][v+2] != OKRAJ)) { tah[i] = ((u-1-3)+(v+2-3)*8)*64 + u-3+(v-3)*8; if(antiroch == 0) cena[i]=-hodnota_figury(a.pole[u-1][v+2]); i++; }
      if((je_barva(a.pole[u+1][v+2],th) == 0) && (a.pole[u+1][v+2] != OKRAJ)) { tah[i] = ((u+1-3)+(v+2-3)*8)*64 + u-3+(v-3)*8; if(antiroch == 0) cena[i]=-hodnota_figury(a.pole[u+1][v+2]); i++; }
      if((je_barva(a.pole[u+2][v+1],th) == 0) && (a.pole[u+2][v+1] != OKRAJ)) { tah[i] = ((u+2-3)+(v+1-3)*8)*64 + u-3+(v-3)*8; if(antiroch == 0) cena[i]=-hodnota_figury(a.pole[u+2][v+1]); i++; }
      if((je_barva(a.pole[u+2][v-1],th) == 0) && (a.pole[u+2][v-1] != OKRAJ)) { tah[i] = ((u+2-3)+(v-1-3)*8)*64 + u-3+(v-3)*8; if(antiroch == 0) cena[i]=-hodnota_figury(a.pole[u+2][v-1]); i++; }
      if((je_barva(a.pole[u+1][v-2],th) == 0) && (a.pole[u+1][v-2] != OKRAJ)) { tah[i] = ((u+1-3)+(v-2-3)*8)*64 + u-3+(v-3)*8; if(antiroch == 0) cena[i]=-hodnota_figury(a.pole[u+1][v-2]); i++; }
    }

    if((th == 0) && (a.pole[u][v] == PESECW)) {
      if(v == 7+2) navrat = 1;

      if(v == 9) {
        if((je_barva(a.pole[u-1][v+1],th) == 0) && (a.pole[u-1][v+1] != OKRAJ) && (a.pole[u-1][v+1] != NIC)) {
           tah[i] = ((u-1-3)+(v+1-3)*8)*64 + u-3+(v-3)*8 + 64*64*STRELECW; if(antiroch == 0) cena[i]=-hodnota_figury(STRELECW)+pesecw_cena; i++;
           tah[i] = ((u-1-3)+(v+1-3)*8)*64 + u-3+(v-3)*8 + 64*64*KUNW    ; if(antiroch == 0) cena[i]=-hodnota_figury(KUNW)+pesecw_cena; i++;
           tah[i] = ((u-1-3)+(v+1-3)*8)*64 + u-3+(v-3)*8 + 64*64*DAMAW   ; if(antiroch == 0) cena[i]=-hodnota_figury(DAMAW)+pesecw_cena; i++;
           tah[i] = ((u-1-3)+(v+1-3)*8)*64 + u-3+(v-3)*8 + 64*64*VEZW    ; if(antiroch == 0) cena[i]=-hodnota_figury(VEZW)+pesecw_cena; i++;
           }
        if((je_barva(a.pole[u+1][v+1],th) == 0) && (a.pole[u+1][v+1] != OKRAJ) && (a.pole[u+1][v+1] != NIC)) {
           tah[i] = ((u+1-3)+(v+1-3)*8)*64 + u-3+(v-3)*8 + 64*64*STRELECW; if(antiroch == 0) cena[i]=-hodnota_figury(STRELECW)+pesecw_cena; i++;
           tah[i] = ((u+1-3)+(v+1-3)*8)*64 + u-3+(v-3)*8 + 64*64*KUNW; if(antiroch == 0) cena[i]=-hodnota_figury(KUNW)+pesecw_cena; i++;
           tah[i] = ((u+1-3)+(v+1-3)*8)*64 + u-3+(v-3)*8 + 64*64*DAMAW; if(antiroch == 0) cena[i]=-hodnota_figury(DAMAW)+pesecw_cena; i++;
           tah[i] = ((u+1-3)+(v+1-3)*8)*64 + u-3+(v-3)*8 + 64*64*VEZW; if(antiroch == 0) cena[i]=-hodnota_figury(VEZW)+pesecw_cena; i++;
           }
        if(a.pole[u][v+1] == 0) {
           tah[i] = ((u-3)+(v+1-3)*8)*64 + u-3+(v-3)*8 + 64*64*STRELECW; if(antiroch == 0) cena[i]=-hodnota_figury(STRELECW)+pesecw_cena; i++;
           tah[i] = ((u-3)+(v+1-3)*8)*64 + u-3+(v-3)*8 + 64*64*KUNW; if(antiroch == 0) cena[i]=-hodnota_figury(KUNW)+pesecw_cena; i++;
           tah[i] = ((u-3)+(v+1-3)*8)*64 + u-3+(v-3)*8 + 64*64*DAMAW; if(antiroch == 0) cena[i]=-hodnota_figury(DAMAW)+pesecw_cena; i++;
           tah[i] = ((u-3)+(v+1-3)*8)*64 + u-3+(v-3)*8 + 64*64*VEZW; if(antiroch == 0) cena[i]=-hodnota_figury(VEZW)+pesecw_cena; i++;
           }
      }
      else {
        if((je_barva(a.pole[u-1][v+1],th) == 0) && (a.pole[u-1][v+1] != OKRAJ) && (a.pole[u-1][v+1] != NIC)) { tah[i] = ((u-1-3)+(v+1-3)*8)*64 + u-3+(v-3)*8; if(antiroch == 0) cena[i]=-hodnota_figury(a.pole[u-1][v+1]); i++; }
        if((je_barva(a.pole[u+1][v+1],th) == 0) && (a.pole[u+1][v+1] != OKRAJ) && (a.pole[u+1][v+1] != NIC)) { tah[i] = ((u+1-3)+(v+1-3)*8)*64 + u-3+(v-3)*8; if(antiroch == 0) cena[i]=-hodnota_figury(a.pole[u+1][v+1]); i++; }
        if(a.pole[u][v+1] == 0) { tah[i] = ((u-3)+(v+1-3)*8)*64 + u-3+(v-3)*8; if(antiroch == 0) cena[i] = 0; i++; }
        if((a.pole[u][v+2] == 0) && (v == 4)) { tah[i] = ((u-3)+(v+2-3)*8)*64 + u-3+(v-3)*8; if(antiroch == 0) cena[i] = 0; i++; }
      }
    }

    if((th == 1) && (a.pole[u][v] == PESECB)) {
      if(v == 2+2) navrat = 1;

      if(v == 4) {
        if((je_barva(a.pole[u-1][v-1],th) == 0) && (a.pole[u-1][v-1] != OKRAJ) && (a.pole[u-1][v-1] != NIC)) {
           tah[i] = ((u-1-3)+(v-1-3)*8)*64 + u-3+(v-3)*8 + 64*64*DAMAB; if(antiroch == 0) cena[i]=-hodnota_figury(DAMAB)+pesecb_cena; i++;
           tah[i] = ((u-1-3)+(v-1-3)*8)*64 + u-3+(v-3)*8 + 64*64*VEZB; if(antiroch == 0) cena[i]=-hodnota_figury(VEZB)+pesecb_cena; i++;
           tah[i] = ((u-1-3)+(v-1-3)*8)*64 + u-3+(v-3)*8 + 64*64*STRELECB; if(antiroch == 0) cena[i]=-hodnota_figury(STRELECB)+pesecb_cena; i++;
           tah[i] = ((u-1-3)+(v-1-3)*8)*64 + u-3+(v-3)*8 + 64*64*KUNB; if(antiroch == 0) cena[i]=-hodnota_figury(KUNB)+pesecb_cena; i++;
           }
        if((je_barva(a.pole[u+1][v-1],th) == 0) && (a.pole[u+1][v-1] != OKRAJ) && (a.pole[u+1][v-1] != NIC)) {
           tah[i] = ((u+1-3)+(v-1-3)*8)*64 + u-3+(v-3)*8 + 64*64*DAMAB; if(antiroch == 0) cena[i]=-hodnota_figury(DAMAB)+pesecb_cena; i++;
           tah[i] = ((u+1-3)+(v-1-3)*8)*64 + u-3+(v-3)*8 + 64*64*VEZB; if(antiroch == 0) cena[i]=-hodnota_figury(VEZB)+pesecb_cena; i++;
           tah[i] = ((u+1-3)+(v-1-3)*8)*64 + u-3+(v-3)*8 + 64*64*STRELECB; if(antiroch == 0) cena[i]=-hodnota_figury(STRELECB)+pesecb_cena; i++;
           tah[i] = ((u+1-3)+(v-1-3)*8)*64 + u-3+(v-3)*8 + 64*64*KUNB; if(antiroch == 0) cena[i]=-hodnota_figury(KUNB)+pesecb_cena; i++;
           }
        if(a.pole[u][v-1] == 0) {
           tah[i] = ((u-3)+(v-1-3)*8)*64 + u-3+(v-3)*8 + 64*64*DAMAB; if(antiroch == 0) cena[i]=-hodnota_figury(DAMAB)+pesecb_cena; i++;
           tah[i] = ((u-3)+(v-1-3)*8)*64 + u-3+(v-3)*8 + 64*64*VEZB; if(antiroch == 0) cena[i]=-hodnota_figury(VEZB)+pesecb_cena; i++;
           tah[i] = ((u-3)+(v-1-3)*8)*64 + u-3+(v-3)*8 + 64*64*STRELECB; if(antiroch == 0) cena[i]=-hodnota_figury(STRELECB)+pesecb_cena; i++;
           tah[i] = ((u-3)+(v-1-3)*8)*64 + u-3+(v-3)*8 + 64*64*KUNB; if(antiroch == 0) cena[i]=-hodnota_figury(KUNB)+pesecb_cena; i++;
           }
      }
      else
      {
        if((je_barva(a.pole[u-1][v-1],th) == 0) && (a.pole[u-1][v-1] != OKRAJ) && (a.pole[u-1][v-1] != NIC)) { tah[i] = ((u-1-3)+(v-1-3)*8)*64 + u-3+(v-3)*8; if(antiroch == 0) cena[i]=-hodnota_figury(a.pole[u-1][v-1]); i++; }
        if((je_barva(a.pole[u+1][v-1],th) == 0) && (a.pole[u+1][v-1] != OKRAJ) && (a.pole[u+1][v-1] != NIC)) { tah[i] = ((u+1-3)+(v-1-3)*8)*64 + u-3+(v-3)*8; if(antiroch == 0) cena[i]=-hodnota_figury(a.pole[u+1][v-1]); i++; }
        if(a.pole[u][v-1] == 0) { tah[i] = ((u-3)+(v-1-3)*8)*64 + u-3+(v-3)*8; if(antiroch == 0) cena[i] = 0; i++; }
        if((a.pole[u][v-2] == 0) && (v == 9)) { tah[i] = ((u-3)+(v-2-3)*8)*64 + u-3+(v-3)*8; if(antiroch == 0) cena[i] = 0; i++; }
      }
    }

    if(((th == 0) && (a.pole[u][v] == KRALW)) || ((th == 1) && (a.pole[u][v] == KRALB))) {

      if((je_barva(a.pole[u-1][v-1],th) == 0) && (a.pole[u-1][v-1] != OKRAJ)) { tah[i] = ((u-1-3)+(v-1-3)*8)*64 + u-3+(v-3)*8; if(antiroch == 0) cena[i]=-hodnota_figury(a.pole[u-1][v-1]); i++; }
      if((je_barva(a.pole[u-1][v-0],th) == 0) && (a.pole[u-1][v-0] != OKRAJ)) { tah[i] = ((u-1-3)+(v-0-3)*8)*64 + u-3+(v-3)*8; if(antiroch == 0) cena[i]=-hodnota_figury(a.pole[u-1][v-0]); i++; }
      if((je_barva(a.pole[u-1][v+1],th) == 0) && (a.pole[u-1][v+1] != OKRAJ)) { tah[i] = ((u-1-3)+(v+1-3)*8)*64 + u-3+(v-3)*8; if(antiroch == 0) cena[i]=-hodnota_figury(a.pole[u-1][v+1]); i++; }
      if((je_barva(a.pole[u-0][v-1],th) == 0) && (a.pole[u-0][v-1] != OKRAJ)) { tah[i] = ((u-0-3)+(v-1-3)*8)*64 + u-3+(v-3)*8; if(antiroch == 0) cena[i]=-hodnota_figury(a.pole[u-0][v-1]); i++; }
      if((je_barva(a.pole[u+0][v+1],th) == 0) && (a.pole[u+0][v+1] != OKRAJ)) { tah[i] = ((u+0-3)+(v+1-3)*8)*64 + u-3+(v-3)*8; if(antiroch == 0) cena[i]=-hodnota_figury(a.pole[u+0][v+1]); i++; }
      if((je_barva(a.pole[u+1][v-1],th) == 0) && (a.pole[u+1][v-1] != OKRAJ)) { tah[i] = ((u+1-3)+(v-1-3)*8)*64 + u-3+(v-3)*8; if(antiroch == 0) cena[i]=-hodnota_figury(a.pole[u+1][v-1]); i++; }
      if((je_barva(a.pole[u+1][v-0],th) == 0) && (a.pole[u+1][v-0] != OKRAJ)) { tah[i] = ((u+1-3)+(v-0-3)*8)*64 + u-3+(v-3)*8; if(antiroch == 0) cena[i]=-hodnota_figury(a.pole[u+1][v-0]); i++; }
      if((je_barva(a.pole[u+1][v+1],th) == 0) && (a.pole[u+1][v+1] != OKRAJ)) { tah[i] = ((u+1-3)+(v+1-3)*8)*64 + u-3+(v-3)*8; if(antiroch == 0) cena[i]=-hodnota_figury(a.pole[u+1][v+1]); i++; }
    }

    if((((th == 0) && (a.pole[u][v] == VEZW)) || ((th == 1) && (a.pole[u][v] == VEZB))) || (((th == 0) && (a.pole[u][v] == DAMAW)) || ((th == 1) && (a.pole[u][v] == DAMAB))) || (((th == 0) && (a.pole[u][v] == TNSW)) || ((th == 1) && (a.pole[u][v] == TNSB)))) {
      for(x = u+1; x <= 10; x++) {
        if(a.pole[x][v] == NIC) { tah[i] = ((x-3)+(v-3)*8)*64 + u-3+(v-3)*8; if(antiroch == 0) cena[i] = 0; i++; }
        if((a.pole[x][v] != NIC) && (a.pole[x][v] != OKRAJ)) {
          if(je_barva(a.pole[x][v],th) == 0)
            { tah[i] = ((x-3)+(v-3)*8)*64 + u-3+(v-3)*8; if(antiroch == 0) cena[i]=-hodnota_figury(a.pole[x][v]); i++; break; }
          else
            break;
        }
      }
      for(x = u-1; x >=  3; x--) {
        if(a.pole[x][v] == NIC) { tah[i] = ((x-3)+(v-3)*8)*64 + u-3+(v-3)*8; if(antiroch == 0) cena[i] = 0; i++; }
        if((a.pole[x][v] != NIC) && (a.pole[x][v] != OKRAJ)) {
          if(je_barva(a.pole[x][v],th) == 0)
            { tah[i] = ((x-3)+(v-3)*8)*64 + u-3+(v-3)*8; if(antiroch == 0) cena[i]=-hodnota_figury(a.pole[x][v]); i++; break; }
          else
            break;
        }
      }
      for(y = v+1; y <= 10; y++) {
        if(a.pole[u][y] == NIC) { tah[i] = ((u-3)+(y-3)*8)*64 + u-3+(v-3)*8; if(antiroch == 0) cena[i] = 0; i++; }
        if((a.pole[u][y] != NIC) && (a.pole[u][y] != OKRAJ)) {
          if(je_barva(a.pole[u][y],th) == 0)
            { tah[i] = ((u-3)+(y-3)*8)*64 + u-3+(v-3)*8; if(antiroch == 0) cena[i]=-hodnota_figury(a.pole[u][y]); i++; break; }
          else
            break;
        }
      }
      for(y = v-1; y >=  3; y--) {
        if(a.pole[u][y] == NIC) { tah[i] = ((u-3)+(y-3)*8)*64 + u-3+(v-3)*8; if(antiroch == 0) cena[i] = 0; i++; }
        if((a.pole[u][y] != NIC) && (a.pole[u][y] != OKRAJ)) {
          if(je_barva(a.pole[u][y],th) == 0)
            { tah[i] = ((u-3)+(y-3)*8)*64 + u-3+(v-3)*8; if(antiroch == 0) cena[i]=-hodnota_figury(a.pole[u][y]); i++; break; }
          else
            break;
        }
      }
    }
    if((((th == 0) && (a.pole[u][v] == STRELECW)) || ((th == 1) && (a.pole[u][v] == STRELECB))) || (((th == 0) && (a.pole[u][v] == DAMAW)) || ((th == 1) && (a.pole[u][v] == DAMAB))) || (((th == 0) && (a.pole[u][v] == TNSW)) || ((th == 1) && (a.pole[u][v] == TNSB)))) {
      if((na_tahu == 0) && (a.pole[u][v] == STRELECW) && (((u == 8+2) && (v == 7+2) && (a.pole[7+2][6+2] == PESECB)) || ((u == 1+2) && (v == 7+2) && (a.pole[2+2][6+2] == PESECB)))) navrat = 1;
      if((na_tahu == 1) && (a.pole[u][v] == STRELECB) && (((u == 8+2) && (v == 2+2) && (a.pole[7+2][3+2] == PESECW)) || ((u == 1+2) && (v == 2+2) && (a.pole[2+2][3+2] == PESECW)))) navrat = 1;

      x = u+1; y = v+1;
      while((x <= 10) && (y <= 10)) {
        if(a.pole[x][y] == NIC) { tah[i] = ((x-3)+(y-3)*8)*64 + u-3+(v-3)*8; if(antiroch == 0) cena[i] = 0; i++; }
        if((a.pole[x][y] != NIC) && (a.pole[x][y] != OKRAJ)) {
          if(je_barva(a.pole[x][y],th) == 0)
            { tah[i] = ((x-3)+(y-3)*8)*64 + u-3+(v-3)*8; if(antiroch == 0) cena[i]=-hodnota_figury(a.pole[x][y]); i++; break; }
          else
            break;
        }
        x++; y++;
      }
      x = u-1; y = v-1;
      while((x >= 3) && (y >= 3)) {
        if(a.pole[x][y] == NIC) { tah[i] = ((x-3)+(y-3)*8)*64 + u-3+(v-3)*8; if(antiroch == 0) cena[i] = 0; i++; }
        if((a.pole[x][y] != NIC) && (a.pole[x][y] != OKRAJ)) {
          if(je_barva(a.pole[x][y],th) == 0)
            { tah[i] = ((x-3)+(y-3)*8)*64 + u-3+(v-3)*8; if(antiroch == 0) cena[i]=-hodnota_figury(a.pole[x][y]); i++; break; }
          else
            break;
        }
        x--; y--;
      }
      x = u+1; y = v-1;
      while((x <= 10) && (y >= 3)) {
        if(a.pole[x][y] == NIC) { tah[i] = ((x-3)+(y-3)*8)*64 + u-3+(v-3)*8; if(antiroch == 0) cena[i] = 0; i++; }
        if((a.pole[x][y] != NIC) && (a.pole[x][y] != OKRAJ)) {
          if(je_barva(a.pole[x][y],th) == 0)
            { tah[i] = ((x-3)+(y-3)*8)*64 + u-3+(v-3)*8; if(antiroch == 0) cena[i]=-hodnota_figury(a.pole[x][y]); i++; break; }
          else
            break;
        }
        x++; y--;
      }
      x = u-1; y = v+1;
      while((x >= 3) && (y <= 10)) {
        if(a.pole[x][y] == NIC) { tah[i] = ((x-3)+(y-3)*8)*64 + u-3+(v-3)*8; if(antiroch == 0) cena[i] = 0; i++; }
        if((a.pole[x][y] != NIC) && (a.pole[x][y] != OKRAJ)) {
          if(je_barva(a.pole[x][y],th) == 0)
            { tah[i] = ((x-3)+(y-3)*8)*64 + u-3+(v-3)*8; if(antiroch == 0) cena[i]=-hodnota_figury(a.pole[x][y]); i++; break; }
          else
            break;
        }
        x--; y++;
      }
    }


    if(((th == 0) && (a.pole[u][v] == KRALW))) {
      if((u == 7) && (v == 3) && (antiroch == 0)) {
        if((a.pole[8][3] == NIC) && (a.pole[9][3] == NIC) && (a.pole[10][3] == VEZW) && (a.rosadaw[0] == 1))
          {
            for(x = 0; x < TAHU; x++) { kava[x] = tah[x]; /*lava[x] = cena[x];*/ }
            if(th == 1) y = 0; else y = 1;
            antiroch = 1;
            gen(a,y);
            antiroch = 0;
            y = 0;
            for(x = 0; x < TAHU; x++) {
              if((((tah[x] % (64*64) - (tah[x] % 64))/64) == 5) || (((tah[x] % (64*64) - (tah[x] % 64))/64) == 4)) y = 1;
              tah[x] = kava[x];
              //cena[x] = lava[x];
            }
            if(y == 0) { tah[i] = -2; if(antiroch == 0) cena[i] = 0; i++; }
          }
        if((a.pole[6][3] == NIC) && (a.pole[5][3] == NIC) && (a.pole[4][3] == NIC) && (a.pole[3][3] == VEZW) && (a.rosadaw[1] == 1))
          {
            for(x = 0; x < TAHU; x++) { kava[x] = tah[x]; /*lava[x] = cena[x];*/ }
            if(th == 1) y = 0; else y = 1;
            antiroch = 1;
            gen(a,y);
            antiroch = 0;
            y = 0;
            for(x = 0; x < TAHU; x++) {
              if((((tah[x] % (64*64) - (tah[x] % 64))/64) == 3) || (((tah[x] % (64*64) - (tah[x] % 64))/64) == 4)) y = 1;
              tah[x] = kava[x];
              //cena[x] = lava[x];
            }
            if(y == 0) { tah[i] = -4; if(antiroch == 0) cena[i] = 0; i++; }
          }
      }
    }
    if(((th == 1) && (a.pole[u][v] == KRALB))) {
      if((u == 7) && (v == 10) && (antiroch == 0)) {
        if((a.pole[8][10] == NIC) && (a.pole[9][10] == NIC) && (a.pole[10][10] == VEZB) && (a.rosadab[0] == 1))
          {
            for(x = 0; x < TAHU; x++) { kava[x] = tah[x]; /*lava[x] = cena[x];*/ }
            if(th == 1) y = 0; else y = 1;
            antiroch = 1; // kvuli tosadovemu zacykleni
            gen(a,y);
            antiroch = 0;
            y = 0;
            for(x = 0; x < TAHU; x++) {
              if((((tah[x] % (64*64) - (tah[x] % 64))/64) == 61) || (((tah[x] % (64*64) - (tah[x] % 64))/64) == 60)) y = 1;
              tah[x] = kava[x];
              //cena[x] = lava[x];
            }
            if(y == 0) { tah[i] = -3; if(antiroch == 0) cena[i] = 0; i++; }
          }

        if((a.pole[6][10] == NIC) && (a.pole[5][10] == NIC) && (a.pole[4][10] == NIC) && (a.pole[3][10] == VEZB) && (a.rosadab[1] == 1))
          {
            for(x = 0; x < TAHU; x++) { kava[x] = tah[x]; /*lava[x] = cena[x];*/ }
            if(th == 1) y = 0; else y = 1;
            antiroch = 1;
            gen(a,y);
            antiroch = 0;
            y = 0;
            for(x = 0; x < TAHU; x++) {
              if((((tah[x] % (64*64) - (tah[x] % 64))/64) == 59) || (((tah[x] % (64*64) - (tah[x] % 64))/64) == 60)) y = 1;
              tah[x] = kava[x];
              //cena[x] = lava[x];
            }
            if(y == 0) { tah[i] = -5; if(antiroch == 0) cena[i] = 0; i++; }
          }
      }
    }
  }
  tah_pocet = i;

  return(navrat);
}

int je_barva(long i,short int tah) {
// pokud je i stejne barvy jako je na tahu, 1 else 0
if(tah == 0) {
  if((i == PESECW) || (i == KUNW) || (i == STRELECW) || (i == VEZW) || (i == DAMAW) || (i == KRALW))
    return(1);
  else return(0);
  }
  else
  {
  if((i == PESECB) || (i == KUNB) || (i == STRELECB) || (i == VEZB) || (i == DAMAB) || (i == KRALB))
    return(1);
  else return(0);
  }
}

SACH tahni(SACH a, long th) {
  int u,v,co,kam,x,y,pom,izo,vol,kry,blo,opo,sou,oldx,oldy;
  if(th == 0) return(a);
  if(th == -2) { a.pole[7][3] = NIC; a.pole[8][3] = VEZW; a.pole[9][3] = KRALW; a.pole[10][3] = NIC; a.rosadaw[0] = 2; return(a);  }
  if(th == -4) { a.pole[7][3] = NIC; a.pole[6][3] = VEZW; a.pole[5][3] = KRALW; a.pole[4][3] = NIC; a.pole[3][3] = NIC; a.rosadaw[1] = 2; return(a);  }
  if(th == -3) { a.pole[7][10] = NIC; a.pole[8][10] = VEZB; a.pole[9][10] = KRALB; a.pole[10][10] = NIC; a.rosadab[0] = 2; return(a);  }
  if(th == -5) { a.pole[7][10] = NIC; a.pole[6][10] = VEZB; a.pole[5][10] = KRALB; a.pole[4][10] = NIC; a.pole[3][10] = NIC; a.rosadab[1] = 2; return(a);  }
  co = th % 64;
  u = co % 8 + 3;
  v = (co - (co % 8))/8 + 3;
  if((a.pole[u][v] == NIC) || (th == -1)) // pat;
    return(a);
  if((((u == 7) && (v == 3)) || ((u == 10) && (v == 3))) && (a.rosadaw[0] == 1)) a.rosadaw[0] = 0;
  if((((u == 7) && (v == 10)) || ((u == 10) && (v == 10))) && (a.rosadab[0] == 1)) a.rosadab[0] = 0;
  if((((u == 3) && (v == 3)) || ((u == 7) && (v == 3))) && (a.rosadaw[1] == 1)) a.rosadaw[1] = 0;
  if((((u == 3) && (v == 10)) || ((u == 7) && (v == 10))) && (a.rosadab[1] == 1)) a.rosadab[1] = 0;
  kam = (th % (64*64) - (th % 64))/64;
  x = kam % 8 + 3;
  y = (kam - (kam % 8))/8 + 3;

  a.pole[x][y] = a.pole[u][v];
  if((kam = (th - (th % (64*64)))/(64*64)) != 0)
    a.pole[x][y] = kam;
  a.pole[u][v] = NIC;

    for(co = 0; co < 8; co++) {
        izo = 0; vol = 0; kry = 0; blo = 0; opo = 0; sou = 0;
      if(a.pole[a.pesecw[co].x][a.pesecw[co].y] != PESECW) {

        oldx = a.pesecw[co].x;
        oldy = a.pesecw[co].y;
        if((a.pole[x][y] != PESECW) && (a.pole[u][v] != PESECW)) {
          a.pesecw[co].x = -1;
          a.pesecw[co].y = -1;
          a.pesecw[co].priznak = -1;
          }
        if((a.pole[u][v] == PESECW) && (oldx != -1)) {
          a.pesecw[co].x = u;
          a.pesecw[co].y = v;
          a.pesecw[co].priznak = -1;
          }
        if((a.pole[x][y] == PESECW) && (oldx != -1)) {
          a.pesecw[co].x = x;
          a.pesecw[co].y = y;
          a.pesecw[co].priznak = -1;
          }

        a.barevnost.wnab += -((barva_pole(oldx,oldy) == 0) ? 1 : 0) + (((barva_pole(a.pesecw[co].x,a.pesecw[co].y) == 0) && a.pesecw[co].y != -1) ? 1 : 0);
        a.barevnost.wnab += -((barva_pole(oldx,oldy) == 1) ? 1 : 0) + (((barva_pole(a.pesecw[co].x,a.pesecw[co].y) == 1) && a.pesecw[co].y != -1) ? 1 : 0);
      }
        for(pom = 0; pom < 8; pom++) {
          if((a.pesecw[pom].x == a.pesecw[co].x-1) || (a.pesecw[pom].x == a.pesecw[co].x+1)) izo = 1;
          if((a.pesecb[pom].y > a.pesecw[co].y) && (abs(a.pesecb[pom].x - a.pesecw[co].x) <= 1)) vol = 1;
          if((a.pole[a.pesecw[co].x-1][a.pesecw[co].y-1] == PESECW) || (a.pole[a.pesecw[co].x+1][a.pesecw[co].y-1] == PESECW)) kry = 1;
          if(a.pole[a.pesecw[co].x][a.pesecw[co].y+1] == PESECB) blo = 1;
          if((a.pole[a.pesecw[co].x-1][a.pesecw[co].y] == PESECW) || (a.pole[a.pesecw[co].x+1][a.pesecw[co].y] == PESECW)) sou = 1;
          // opo ??
          }
        if(izo == 1) a.pesecw[co].priznak = 0; else a.pesecw[co].priznak = 1;
        if(vol == 0) a.pesecw[co].priznak += 2;
        if(kry == 1) a.pesecw[co].priznak += 4;
        if(blo == 1) a.pesecw[co].priznak += 8;
        if(sou == 1) a.pesecw[co].priznak += 32;
    }

    for(co = 0; co < 8; co++) {
        izo = 0; vol = 0; kry = 0; blo = 0; opo = 0; sou = 0;
      if(a.pole[a.pesecb[co].x][a.pesecb[co].y] != PESECB) {

        oldx = a.pesecb[co].x;
        oldy = a.pesecb[co].y;
        if((a.pole[x][y] != PESECB) && (a.pole[u][v] != PESECB)) {
          a.pesecb[co].x = -1;
          a.pesecb[co].y = -1;
          a.pesecb[co].priznak = -1;
          }
        if((a.pole[u][v] == PESECB) && (oldx != -1)) {
          a.pesecb[co].x = u;
          a.pesecb[co].y = v;
          a.pesecb[co].priznak = -1;
          }
        if((a.pole[x][y] == PESECB) && (oldx != -1)) {
          a.pesecb[co].x = x;
          a.pesecb[co].y = y;
          a.pesecb[co].priznak = -1;
          }

        a.barevnost.bnab += -((barva_pole(oldx,oldy) == 0) ? 1 : 0) + (((barva_pole(a.pesecw[co].x,a.pesecb[co].y) == 0) && a.pesecb[co].y != -1) ? 1 : 0);
        a.barevnost.bnab += -((barva_pole(oldx,oldy) == 1) ? 1 : 0) + (((barva_pole(a.pesecw[co].x,a.pesecb[co].y) == 1) && a.pesecb[co].y != -1) ? 1 : 0);
      }
        for(pom = 0; pom < 8; pom++) {
          if((a.pesecb[pom].x == a.pesecb[co].x-1) || (a.pesecb[pom].x == a.pesecb[co].x+1)) izo = 1;
          if((a.pesecw[pom].y < a.pesecb[co].y) && (abs(a.pesecw[pom].x - a.pesecb[co].x) <= 1)) vol = 1;
          if((a.pole[a.pesecb[co].x-1][a.pesecb[co].y+1] == PESECB) || (a.pole[a.pesecb[co].x+1][a.pesecb[co].y+1] == PESECB)) kry = 1;
          if(a.pole[a.pesecb[co].x][a.pesecb[co].y-1] == PESECW) blo = 1;
          if((a.pole[a.pesecb[co].x-1][a.pesecb[co].y] == PESECB) || (a.pole[a.pesecb[co].x+1][a.pesecb[co].y] == PESECB)) sou = 1;
          // sou ??
          }
        if(izo == 1) a.pesecb[co].priznak = 0; else a.pesecb[co].priznak = 1;
        if(vol == 0) a.pesecb[co].priznak += 2;
        if(kry == 1) a.pesecb[co].priznak += 4;
        if(blo == 1) a.pesecb[co].priznak += 8;
        if(sou == 1) a.pesecb[co].priznak += 32;
    }

  return(a);
}

long hodnoceni(SACH a, int natahu) { // hodnoceni vzhledem k bilemu, krmi tah[i]
  int u,v;
  long na = 0,pat;
  for(u = 3; u <= 10; u++)
    for(v = 3; v <= 10; v++) {
      if(a.pole[u][v] == PESECW) { // rozpracovat dale;
         na += pesecw_cena;
         if((u == 6) ||(u == 7) || (v == 6) || (u == 6)) na += stredovypesec;
         }
      if(a.pole[u][v] == PESECB) {
         na += pesecb_cena;
         if((u == 6) ||(u == 7) || (v == 6) || (u == 6)) na -= stredovypesec;
         }
      if(a.pole[u][v] == STRELECW) na += strelecw_cena;
      if(a.pole[u][v] == STRELECB) na += strelecb_cena;
      if(a.pole[u][v] == DAMAW) na += damaw_cena;
      if(a.pole[u][v] == DAMAB) na += damab_cena;
      if(a.pole[u][v] == VEZW) na += vezw_cena;
      if(a.pole[u][v] == VEZB) na += vezb_cena;
      if(a.pole[u][v] == KUNW) na += kunw_cena;
      if(a.pole[u][v] == KUNB) na += kunb_cena;
      if(a.pole[u][v] == KRALW) na +=  100000000;
      if(a.pole[u][v] == KRALB) na += -100000000;
      if(a.pole[u][v] == TNSW) na += tnsw_cena;
      if(a.pole[u][v] == TNSB) na += tnsb_cena;
    }
  if(a.rosadaw[0] == 1) na += rosadamw;
  if(a.rosadaw[1] == 1) na += rosadavw;
  if(a.rosadab[0] == 1) na += rosadamb;
  if(a.rosadab[1] == 1) na += rosadavb;

  if(a.rosadaw[0] == 2) na += rosadamwOK;
  if(a.rosadaw[1] == 2) na += rosadavwOK;
  if(a.rosadab[0] == 2) na += rosadambOK;
  if(a.rosadab[1] == 2) na += rosadavbOK;

  gen(a,natahu);
  pat = tah_pocet;
  if (natahu = 1) u = -1; else u = 1;
  na += tah_pocet*volnepole_cena*u;
/*
  if(natahu == 1) natahu = 0; else natahu = 1;
  gen(a,natahu);  //silne nepovinne
  if (natahu = 0) u = -1; else u = 1;
  na += tah_pocet*volnepole_cena*u;*/
  if(pat == 0) na = 0;
  return(na);

}

DPTH depthsearch(SACH a, long nath, int dpth_max, int dpth_start,long hodn_navr_min) {
  // vraci samozrejme hodnoceni pozice a v hloubce dpth_max,
  // variantu je potreba nejak nakrmit jinam (do depth.poradi_tahu)
  // tam se ale uklada nejlepsi varianta

  DPTH navrat, pom;
  int tah_krat, c,     x,y,u,v;
  int pocet_tahu, poradi_tahu, chyceny_strelec;
  long soukromy_tah[TAHU]; //aby se numusel v novem listu pokazde generovat
  long aa,bb,k, soukroma_cena[TAHU]; // pro kaskady

  if(dpth_start == 0)
    poz = 0;
  poz++;
  if((labs(hodnoceni(a,nath)) > 50000000) && (dpth_start == 0)) { printf("Hra je u konce.\n"); getch(); return(navrat); }
  if(nath == 0) tah_krat = 1; else tah_krat = -1;
  navrat.hodnoceni = -1500000000*tah_krat; navrat.poradi_tahu = -1;
  if(dpth_max == dpth_start) {
    navrat.hodnoceni = hodnoceni(a,nath);
    navrat.poradi_tahu = -1; // tedy jde o list
    return(navrat);
  }

  chyceny_strelec = gen(a,nath);
  pocet_tahu = tah_pocet;
  bubble_tah(tah_krat);

  if((kaskada == 0) && (dpth_start == 0)) {
    kaskada = 1;
    depthsearch(a,nath,dep-1,0,-1500000000*((nath==0) ? 1 : -1));
    kaskada = 0;
    }

  for(poradi_tahu = 0; poradi_tahu <= pocet_tahu; poradi_tahu++)
    soukromy_tah[poradi_tahu] = tah[poradi_tahu];

    if((kaskada == 1) && (dpth_start == 0)) // ulozi cenu, aby ji mohl zmenit
    for(poradi_tahu = 0; poradi_tahu < TAHU; poradi_tahu++)  {
      soukroma_cena[poradi_tahu] = cena[poradi_tahu];
      soukromy_tah[poradi_tahu] = tah[poradi_tahu];
      }

  if((dpth_start+1) == dpth_max) {
    aa = 0;
    for(c = 0; c < tah_pocet; c++) { // jeden hrac
      k = (tah[c] % (64*64) - (tah[c] % 64))/64;
      x = k % 8 + 3;
      y = (k - (k % 8))/8 + 3;
      if((a.pole[x][y] == KRALW) || (a.pole[x][y] == KRALB) || (chyceny_strelec == 1)) aa = 1;
    }

    antiroch = 1;
    x = ((nath == 0) ? 1 : 0); // metoda nuloveho tahu
    chyceny_strelec = gen(a,x); // nulovy tah - maximalne vyuzit
    antiroch = 0;
    for(c = 0; c < tah_pocet; c++) {
      k = (tah[c] % (64*64) - (tah[c] % 64))/64;
      x = k % 8 + 3;
      y = (k - (k % 8))/8 + 3;
      if((a.pole[x][y] == KRALW) || (a.pole[x][y] == KRALB) || (chyceny_strelec == 1)) aa = 1;
    }

    if((aa == 1) && (kaskada != 1) && (dpth_max < (dep+1)))
      dpth_max++;
  }



  if(pocet_tahu == 0) {
    navrat.hodnoceni = hodnoceni(a,nath);
    navrat.poradi_tahu = -1; // nelze tahnout... tedy jde o list
    return(navrat);
  }
  for(poradi_tahu = 0; poradi_tahu < pocet_tahu; poradi_tahu++) {
    pom = depthsearch(tahni(a,soukromy_tah[poradi_tahu]),((nath == 1) ? 0 : 1),dpth_max,dpth_start+1,navrat.hodnoceni);
    if((kaskada == 1) && (dpth_start == 0)) soukroma_cena[poradi_tahu] = pom.hodnoceni;
    if((pom.hodnoceni*tah_krat) > (navrat.hodnoceni*tah_krat)) {

      navrat.hodnoceni = pom.hodnoceni;
      navrat.poradi_tahu = soukromy_tah[poradi_tahu]; //nebo tah[poradi_tahu]
      if((dpth_start <= 0) && 0) {
        c = navrat.poradi_tahu % 64;
        u = c % 8 + 3;
        v = (c - (c % 8))/8 + 3;
        c = (navrat.poradi_tahu % (64*64) - (navrat.poradi_tahu % 64))/64;
        x = c % 8 + 3;
        y = (c - (c % 8))/8 + 3;

      printf("(%D) %d %d -> %d %d %D\n",dpth_start, u-2,v-2,x-2,y-2,navrat.hodnoceni);
      getch(); }
      aa = navrat.hodnoceni*tah_krat;
      bb = hodn_navr_min*tah_krat*(1);
      if((aa > bb) && (labs(hodn_navr_min) != 1500000000))
         return(navrat);//alfa,beta

       // tady se musi vypisovat best varianta
    }
  if(dpth_start == 0) {
    user_see(a, navrat.hodnoceni);
    printf("%D/%D\t\t%D\n",poradi_tahu+1,pocet_tahu,poz);
    if(kaskada == 1) printf("serazovaci kaskada pro zmenseni okna alpha, beta\n");
    }


  }
  if((kaskada == 1) && (dpth_start == 0)) {
    for(x = 0; x < TAHU; x++) {
      cena[x] = soukroma_cena[x];
      tah[x] = soukromy_tah[x];
    }
    bubble_tah(tah_krat);
  }

  return(navrat);

}

long konzole(void) {
  char u,v,x,y,a, prikaz[500];
  long tah = 0;
  printf("?\n");
  while(1) {
    u = getch();
    if(u == 27) exit(0);
    if(u == '+') { // skutecna konzole
      printf("Zadat prikaz: "); scanf("%s",prikaz);
      if((strcmp(prikaz,"new")) == 0) return(-10);
      if((strcmp(prikaz,"nova")) == 0) return(-10);
      if((strcmp(prikaz,"novy")) == 0) return(-10);
      if((strcmp(prikaz,"znovu")) == 0) return(-10);
      if((strcmp(prikaz,"exit")) == 0) exit(0);
      if((strcmp(prikaz,"konec")) == 0) exit(0);
      if((strcmp(prikaz,"quit")) == 0) exit(0);
      if(((strcmp(prikaz,"figury")) == 0) || ((strcmp(prikaz,"hodnoty")) == 0)) {
        printf("Pesec bily %D> \t\t\t",pesecw_cena); scanf("%D", &pesecw_cena);
        printf("Pesec cerny %D> \t\t\t",pesecb_cena); scanf("%D", &pesecb_cena);
        printf("Jezdec bily %D> \t\t\t",kunw_cena); scanf("%D", &kunw_cena);
        printf("Jezdec cerny %D> \t\t\t",kunb_cena); scanf("%D", &kunb_cena);
        printf("Strelec bily %D> \t\t\t",strelecw_cena); scanf("%D", &strelecw_cena);
        printf("Strelec cerny %D> \t\t\t",strelecb_cena); scanf("%D", &strelecb_cena);
        printf("Vez bila %D> \t\t\t\t",vezw_cena); scanf("%D", &vezw_cena);
        printf("Vez temna %D> \t\t\t",vezb_cena); scanf("%D", &vezb_cena);
        printf("Dama bila %D> \t\t\t",damaw_cena); scanf("%D", &damaw_cena);
        printf("Dama cerna %D> \t\t\t",damab_cena); scanf("%D", &damab_cena);
        printf("Rosada mala bila hotova %D> \t\t",rosadamwOK); scanf("%D", &rosadamwOK);
        printf("Rosada velka bila hotova %D> \t\t",rosadavwOK); scanf("%D", &rosadavwOK);
        printf("Rosada mala cerna hotova %D> \t\t",rosadambOK); scanf("%D", &rosadambOK);
        printf("Rosada velka cerna hotova %D> \t",rosadavbOK); scanf("%D", &rosadavbOK);
        printf("Rosada mala bila mozna %D> \t\t",rosadamw); scanf("%D", &rosadamw);
        printf("Rosada velka bila mozna %D> \t\t",rosadavw); scanf("%D", &rosadavw);
        printf("Rosada mala cerna mozna %D> \t\t",rosadamb); scanf("%D", &rosadamb);
        printf("Rosada velka cerna mozna %D> \t\t",rosadavb); scanf("%D", &rosadavb);
        printf("Volne pole %D> \t\t\t\t",volnepole_cena); scanf("%D", &volnepole_cena);
        printf("Pesec na stredu %D> \t\t\t",stredovypesec); scanf("%D", &stredovypesec);
      }
      if(((strcmp(prikaz,"depth")) == 0) || ((strcmp(prikaz,"hloubka")) == 0)) {
        printf("Zadat hloubku> "); scanf("%d", &dep);
        if(dep == 1) { kaskada = 2; printf("Kaskadovani vypnuto...\n"); }
      }
      if(((strcmp(prikaz,"kaskada")) == 0) || ((strcmp(prikaz,"kask")) == 0)) {
        if(kaskada == 0) { printf("Kaskadovani vypnuto...\n"); kaskada = 2; }
        else { printf("Kaskadovani zapnuto...\n"); kaskada = 0; }
      }
      if(((strcmp(prikaz,"help")) == 0) || ((strcmp(prikaz,"pomoc")) == 0)) {
      printf("tahy se zadavaji ve formatu e2e4, pro nasazeni damy stisknout '-', potom \nfiguru a pak tah - napr. -de7e8 nasadi damu\n");
      printf("v konzoli> help, kask, depth, new, figury, exit\n");
      }

    }

    if(u == '-') { u = getch();
    if((u != 'd') && (u != 'D') && (u != 'j') && (u != 'J') && (u != 's') && (u != 'S') && (u != 'g') && (u != 'v') && (u != 'V')) continue;
    if((u == 'd') || (u == 'D')) tah =  64*64*((tahne == BILY) ? DAMAW : DAMAB);
    if((u == 'v') || (u == 'V')) tah =  64*64*((tahne == BILY) ? DAMAW : DAMAB);
    if((u == 's') || (u == 'S')) tah =  64*64*((tahne == BILY) ? DAMAW : DAMAB);
    if((u == 'j') || (u == 'J')) tah =  64*64*((tahne == BILY) ? DAMAW : DAMAB);
    u = getch();
    }


    if((u != 'a') && (u != 'b') && (u != 'c') && (u != 'd') && (u != 'e') && (u != 'f') && (u != 'g') && (u != 'h') && (u != 'A') && (u != 'B') && (u != 'C') && (u != 'D') && (u != 'E') && (u != 'F') && (u != 'G') && (u != 'H')) continue;

    if((u == 'A') || (u == 'a')) u =  3;
    if((u == 'B') || (u == 'b')) u =  4;
    if((u == 'C') || (u == 'c')) u =  5;
    if((u == 'D') || (u == 'd')) u =  6;
    if((u == 'E') || (u == 'e')) u =  7;
    if((u == 'F') || (u == 'f')) u =  8;
    if((u == 'G') || (u == 'g')) u =  9;
    if((u == 'H') || (u == 'h')) u = 10;
    a = u;

    u = getch();
    if((u != '1') && (u != '2') && (u != '3') && (u != '4') && (u != '5') && (u != '6') && (u != '7') && (u != '8')) continue;

    if(u == '1') u =  3;
    if(u == '2') u =  4;
    if(u == '3') u =  5;
    if(u == '4') u =  6;
    if(u == '5') u =  7;
    if(u == '6') u =  8;
    if(u == '7') u =  9;
    if(u == '8') u = 10;
    v = u;

    u = getch();
    if((u != 'a') && (u != 'b') && (u != 'c') && (u != 'd') && (u != 'e') && (u != 'f') && (u != 'g') && (u != 'h') && (u != 'A') && (u != 'B') && (u != 'C') && (u != 'D') && (u != 'E') && (u != 'F') && (u != 'G') && (u != 'H')) continue;

    if((u == 'A') || (u == 'a')) u =  3;
    if((u == 'B') || (u == 'b')) u =  4;
    if((u == 'C') || (u == 'c')) u =  5;
    if((u == 'D') || (u == 'd')) u =  6;
    if((u == 'E') || (u == 'e')) u =  7;
    if((u == 'F') || (u == 'f')) u =  8;
    if((u == 'G') || (u == 'g')) u =  9;
    if((u == 'H') || (u == 'h')) u = 10;
    x = u;

    u = getch();
    if((u != '1') && (u != '2') && (u != '3') && (u != '4') && (u != '5') && (u != '6') && (u != '7') && (u != '8')) continue;

    if(u == '1') u =  3;
    if(u == '2') u =  4;
    if(u == '3') u =  5;
    if(u == '4') u =  6;
    if(u == '5') u =  7;
    if(u == '6') u =  8;
    if(u == '7') u =  9;
    if(u == '8') u = 10;
    y = u;
    u = a;

    tah += (u-3)+(v-3)*8 + 64*((x-3)+(y-3)*8);
    if((u == 7) && (v == 3) && (x == 9) && (y == 3)) tah = -2;
    if((u == 7) && (v == 3) && (x == 5) && (y == 3)) tah = -4;
    if((u == 7) && (v == 10) && (x == 9) && (y == 10)) tah = -3;
    if((u == 7) && (v == 10) && (x == 9) && (y == 10)) tah = -5;

    return(tah);

  }
}

void user_see(SACH a, long hodn) {
    clrscr();
    printf("Postoupeck%c veverka version 1.21                    (c) by Jan Irigi Ol%cina 2002Motto: Haluz%ck mezi %cachov%cmi programy...\n\nHodnoceni pozice %6.3f\n\n\n",160,231,160,231,236,((float) hodn)/1000); vypis(a); printf("\n");
}

long hodnota_figury(int f) {
 long na;

 if(f == NIC) na = 0;
 if(f == STRELECW) na = strelecw_cena;
 if(f == STRELECB) na = strelecb_cena;
 if(f == PESECW) na = pesecw_cena;
 if(f == PESECB) na = pesecb_cena;
 if(f == DAMAW) na = damaw_cena;
 if(f == DAMAB) na = damab_cena;
 if(f == VEZW) na = vezw_cena;
 if(f == VEZB) na = vezb_cena;
 if(f == KUNW) na = kunw_cena;
 if(f == KUNB) na = kunb_cena;
 if(f == KRALW) na =  100000000;
 if(f == KRALB) na = -100000000;
 if(f == TNSW) na = tnsw_cena;
 if(f == TNSB) na = tnsb_cena;
 return(na);
}

int bubble_tah(int sign) {
  int i,u,m;
  long pom;

//test
  for(u = 0; u < TAHU; u++) if((tah[u] == -1) && (cena[u] != -1500000000))
    return 0;

  for(u = 0; u <= TAHU; u++) {
    m = 0;
    for(i = 0; i < TAHU-1; i++) {
      if(cena[i+1] == -1500000000) break;
      if(tah[i] == -1)
        getch();
      if((cena[i]*sign) < (cena[i+1]*sign)) {
        m = 1;
        pom = cena[i]; cena[i] = cena[i+1]; cena[i+1] = pom;
        pom = tah[i]; tah[i] = tah[i+1]; tah[i+1] = pom;
      }
    }
  if(m == 0) break;
  }

}

char barva_pole(int u,int v) {
  return((u+v) % 2);
}
